



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MongoDB驱动之Linq操作</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MongoDB驱动之Linq操作</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 02:44:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>添加下面命名空间到您的程序中：</p>
<div>
<pre class="prettyprint linenums">using MongoDB.Driver.Linq;</pre>
</div>
<p>声明一变量保存对集合的引用</p>
<div>
<pre class="prettyprint linenums">var collection = database.GetCollection&lt;TDocument&gt;("collectionname");</pre>
</div>
<p>最基本调用linq查询的方式是构造一个集合变量，通过调用<strong>AsQueryable&lt;TDocument&gt;()</strong>&nbsp;后，你便可以正常调用linq了。</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from e in collection.AsQueryable&lt;Employee&gt;()<br />
    where e.FirstName == "John"<br />
    select e; 

foreach (var employee in query)

{<br />
    // do something<br />
}</pre>
</div>
<p>当然，你也可以通过lambda语法写查询表达式，先前的查询语句等同于下面的写法：</p>
<div>
<pre class="prettyprint linenums">var query = collection.AsQueryable&lt;Employee&gt;().Where(e =&gt; e.FirstName == "John");</pre>
</div>
<p>C#编译器会在内部把所有查询翻译为lambda句法，所以这两种写法没有优略之分，当你需要的时候（比如某些查询操作符不被支持的时候），你甚至可以混用这两种方式。</p>
<p>只有linq查询可以转化为相应的MongoDB查询时该查询才会被支持解析，如果你写的linq查询不能被转化成相应的MongoDB查询，那么您的程序会在产生异常或者错误。</p>
<h1><strong>MongoDB支持的</strong><strong>LINQ</strong><strong>查询操作符</strong></h1>
<ul><li><strong>Any不含谓词的Any只是测试集合中是否存在any文档对象</strong></li></ul>
<p>不含谓词的Any只是测试集合中是否存在any文档对象</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    select c)<br />
    .Any();

// 或者

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Any();</pre>
</div>
<ul><li><strong>Any</strong><strong>&nbsp;</strong><strong>(</strong><strong>含谓词</strong><strong>)</strong></li></ul>
<p>含有谓词的Any用来测试集合中是否存在匹配的文档，匹配逻辑在谓词中</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    select c)<br />
    .Any(c =&gt; c.X == );

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Any(c =&gt; c.X == );</pre>
</div>
<p>投影操作后，带有谓词的Any是不被支持的（至少当前版本），所以下面代码是不可用的。</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Select(c =&gt; c.X)<br />
    .Any(x =&gt; x == );</pre>
</div>
<p>通常来说，你可以使用where字句来替代投影操作，这样你可以移除投影操作。</p>
<ul><li><strong>Count</strong></li></ul>
<p>不带谓词的Count只是返回文档对象在集合中数量。</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    select c)<br />
    .Count();

// 或者

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Count();</pre>
</div>
<ul><li><strong>Count</strong><strong>&nbsp;</strong><strong>(</strong><strong>带谓词</strong><strong>)</strong></li></ul>
<p>带有谓词的Count返回谓词匹配的文档数量。</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    select c)<br />
    .Count(c =&gt; c.X == );

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Count(c =&gt; c.X == );</pre>
</div>
<p>说明：谓词同样可以通过where字句和不带谓词的Count替代，所以上面实例也可以这样写：</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.X ==<br />
    select c)<br />
    .Count();

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.X == )<br />
    .Count();</pre>
</div>
<p>含有谓词的<strong>Count</strong>同样不支持投影后操作，所以下面写法是无效的。</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Select(c =&gt; c.X)<br />
    .Count(x =&gt; x == );</pre>
</div>
<p>解决方案和Any一样。</p>
<ul><li><strong>Distinct</strong></li></ul>
<p><strong>Distinct</strong>&nbsp;返回集合中文档对象字段或者属性的唯一值，你可以投影后通过它过滤重复值。</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    select c.X)<br />
    .Distinct();

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Select(c =&gt; c.X)<br />
    .Distinct();</pre>
</div>
<p>投影必须选择一个特定的字段或属性的文件。如果该字段或属性的值是在MongoDB中表示，作为一个数组，你也可以使用数组索引从数据中选择一项：</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    select c.A[i])<br />
    .Distinct();

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Select(c =&gt; c.A[i])<br />
    .Distinct();</pre>
</div>
<ul><li><strong>ElementAt</strong></li></ul>
<p><strong>ElementAt&nbsp;</strong>从结果集中返回一个特定的文档，通常要和排序操作一起使用</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.X &gt;<br />
    orderby c.X<br />
    select c)<br />
    .ElementAt(index);

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.X &gt; )<br />
    .OrderBy(c =&gt; c.X)<br />
    .ElementAt(index);</pre>
</div>
<p>如果结果集中文档对象数量少于<strong>ElementAt</strong>&nbsp;中索引，会报出异常。</p>
<ul><li><strong>ElementAtOrDefault</strong></li></ul>
<p><strong>ElementAtOrDefault</strong>&nbsp;和<strong>ElementAt</strong>&nbsp;类似，区别在于当集合中对象少于Index时前者返回null而不是报出异常。</p>
<ul><li><strong>First</strong></li></ul>
<p><strong>First</strong>&nbsp;返回集合中第一个对象，通常和排序一起使用。</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.X &gt;<br />
    orderby c.X<br />
    select c)<br />
    .First();

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.X &gt; )<br />
    .OrderBy(c =&gt; c.X)<br />
    .First();</pre>
</div>
<p>如果集合为空，则<strong>First</strong>抛出异常</p>
<ul><li><strong>First</strong><strong>&nbsp;</strong><strong>(</strong><strong>含谓词</strong><strong>)</strong></li></ul>
<p>此重载允许你提供谓词逻辑给First，相当于使用where字句的first查询。</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    orderby c.X<br />
    select c)<br />
    .First(c =&gt; c.X &gt; );

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .OrderBy(c =&gt; c.X)<br />
    .First(c =&gt; c.X &gt; );</pre>
</div>
<p><strong>First</strong>&nbsp;（含有谓词）同样不支持投影后操作，所以下面代码是无效的：</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .OrderBy(c =&gt; c.X)<br />
    .Select(c =&gt; c.X)<br />
    .First(x =&gt; x &gt; );</pre>
</div>
<p>解决方案同样和Any一样</p>
<p>如果集合为空，同样会抛出异常</p>
<ul><li><strong>FirstOrDefault</strong></li></ul>
<p><strong>FirstOrDefault</strong>&nbsp; 和<strong>First</strong>&nbsp;不同之处在于，当集合为空时，不会抛出异常，而是返回null</p>
<ul><li><strong>FirstOrDefault</strong><strong>&nbsp;</strong><strong>(</strong><strong>含谓词</strong><strong>)</strong></li></ul>
<p>FirstOrDefault (含谓词)和First（含谓词）用法一样，不同之处在于，集合为空时，返回null不会抛出异常</p>
<ul><li><strong>Last</strong></li></ul>
<p><strong>Last</strong>&nbsp;从结果集中返回最后一个文档对象，和First相对，通常和排序操作一起使用：</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.X &gt;<br />
    orderby c.X<br />
    select c)<br />
    .Last();

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.X &gt; )<br />
    .OrderBy(c =&gt; c.X)<br />
    .Last();</pre>
</div>
<p>如果集合为空，会抛出异常。</p>
<ul><li><strong>Last</strong><strong>&nbsp;</strong><strong>(</strong><strong>含谓词</strong><strong>)</strong></li></ul>
<p>此重载允许你传递谓词逻辑作为参数给<strong>Last</strong><strong>，</strong>和不带谓词的Last操作加上where字句相当。</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    orderby c.X<br />
    select c)<br />
    .Last(c =&gt; c.X &gt; );

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .OrderBy(c =&gt; c.X)<br />
    .Last(c =&gt; c.X &gt; );</pre>
</div>
<p><strong>Last</strong>&nbsp;同样不支持投影后操作，所以下面写法是无效的：</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .OrderBy(c =&gt; c.X)<br />
    .Select(c =&gt; c.X)<br />
    .Last(x =&gt; x &gt; );</pre>
</div>
<p>解决方案和Any一样。</p>
<p>如果集合为空，会抛出异常</p>
<ul><li><strong>LastOrDefault</strong></li></ul>
<p><strong>LastOrDefault</strong>&nbsp;和&nbsp;<strong>Last</strong>&nbsp;不同之处在于，前者当集合为空时不会抛出异常，只是返回null</p>
<ul><li><strong>LastOrDefault</strong><strong>&nbsp;</strong><strong>(</strong><strong>含谓词</strong><strong>)</strong></li></ul>
<p><strong>LastOrDefault</strong><strong>（含谓词）</strong>和&nbsp;<strong>Last</strong>&nbsp;（含谓词）用法一样，不同之处在于前者在集合为空时返回null，不会抛出异常。</p>
<ul><li><strong>LongCount</strong></li></ul>
<p><strong>LongCount</strong>&nbsp;用法和<strong>Count</strong>&nbsp;一样，不同之处在于返回值前者是64位长整型，后者是32位。</p>
<ul><li><strong>LongCount</strong><strong>&nbsp;</strong><strong>(</strong><strong>含谓词</strong><strong>)</strong></li></ul>
<p><strong>LongCount</strong>&nbsp;（含谓词）和<strong>Count</strong>&nbsp;（含谓词）用法一样，不同之处在于返回值前者是64位长整型，后者是32位。</p>
<ul><li><strong>Max</strong></li></ul>
<p><strong>Max</strong>&nbsp;返回集合中文档对象属性或者字段值中的最大值，你可以筛选出投影操作识别出的字段或者属性的最大值</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    select c.X)<br />
    .Max();

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Select(c =&gt; c.X)<br />
    .Max();</pre>
</div>
<p>投影必须选择一个特定的字段或属性的文件。如果该字段或属性的值是在MongoDB中表示，作为一个数组，你也可以使用数组索引从数据中选择一项：</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    select c.A[i])<br />
    .Max();

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Select(c =&gt; c.A[i])<br />
    .Max();</pre>
</div>
<ul><li><strong>Max</strong><strong>&nbsp;</strong><strong>(</strong><strong>含选择器</strong><strong>)</strong></li></ul>
<p>此<strong>Max</strong>&nbsp;重载可以让你直接传递选择参数到Max来筛选最大值，可以用来代替在投影后进行Max操作：</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    select c)<br />
    .Max(c =&gt; c.X);

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Max(c =&gt; c.X);</pre>
</div>
<ul><li><strong>Min</strong></li></ul>
<p><strong>Min</strong>&nbsp;返回集合中文档对象属性或者字段值中的最小值，你可以筛选出投影操作识别出的字段或者属性的最小值</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    select c.X)<br />
    .Min();

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Select(c =&gt; c.X)<br />
    .Min();</pre>
</div>
<p>投影必须选择一个特定的字段或属性的文件。如果该字段或属性的值是在MongoDB中表示，作为一个数组，你也可以使用数组索引从数据中选择一项：</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    select c.A[i])<br />
    .Min();

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Select(c =&gt; c.A[i])<br />
    .Min();</pre>
</div>
<ul><li><strong>Min</strong><strong>&nbsp;</strong><strong>(</strong><strong>含选择器</strong><strong>)</strong></li></ul>
<p>此<strong>Min</strong>&nbsp;重载可以让你直接传递选择参数到Min来筛选最小值，可以用来代替在投影后进行Min操作：</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    select c)<br />
    .Min(c =&gt; c.X);<br />
// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Min(c =&gt; c.X);</pre>
</div>
<ul><li><strong>OfType</strong></li></ul>
<p><strong>OfType</strong>操作符会向查询插入一个鉴别器以便你更精确的查询文档对象</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;().OfType&lt;D&gt;()<br />
    select c)

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .OfType&lt;D&gt;();</pre>
</div>
<ul><li><strong>OrderBy</strong></li></ul>
<p><strong>OrderBy</strong>&nbsp;用于指定结果集升序排序顺序</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    orderby c.X<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .OrderBy(c =&gt; c.X);</pre>
</div>
<ul><li><strong>OrderByDescending</strong></li></ul>
<p><strong>OrderByDescending</strong>&nbsp;&nbsp;用于指定结果集降序排序顺序</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    orderby c.X descending<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .OrderByDescending(c =&gt; c.X);</pre>
</div>
<ul><li><strong>Select</strong></li></ul>
<p><strong>Select</strong>&nbsp;用于从匹配文档中选出一个新类型的结果集。<strong>Select</strong>&nbsp;必须为最后一个操作（除了如&nbsp;<strong>Distinct</strong>,&nbsp;<strong>Max</strong>&nbsp;和&nbsp;<strong>Min</strong>等）</p>
<p><strong>注意：</strong><strong>Select</strong>&nbsp;不会减少从服务器返回的文档对象字段或者属性，完整的文档对象还是会被返回的，然后才调用<strong>Select</strong>&nbsp;方法，因此投影是在&ldquo;客户端&rdquo;的。</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    select new { c.X, c.Y };

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Select(c =&gt; new { c.X, c.Y });</pre>
</div>
<ul><li><strong>Single</strong></li></ul>
<p><strong>Single</strong>&nbsp;从结果集中返回第一个也是唯一的文件</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.X &gt;<br />
    orderby c.X<br />
    select c)<br />
    .Single();

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.X &gt; )<br />
    .OrderBy(c =&gt; c.X)<br />
    .Single();</pre>
</div>
<p>如果结果集为空或者存在多个文档，<strong>Single</strong>&nbsp;会抛出异常。</p>
<ul><li><strong>Single</strong><strong>&nbsp;</strong><strong>(</strong><strong>含谓词</strong><strong>)</strong></li></ul>
<p>此重载可以传递参数到<strong>Single</strong>&nbsp;，等同于不含谓词的<strong>Single</strong>&nbsp;加上where字句。</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    orderby c.X<br />
    select c)<br />
    .Single(c =&gt; c.X &gt; );

// or

var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .OrderBy(c =&gt; c.X)<br />
    .Single(c =&gt; c.X &gt; );</pre>
</div>
<p><strong>Single</strong>&nbsp;同样不支持投影后操作，所以下面代码是无效的：</p>
<div>
<pre class="prettyprint linenums">var result =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .OrderBy(c =&gt; c.X)<br />
    .Select(c =&gt; c.X)<br />
    .Single(x =&gt; x &gt; );</pre>
</div>
<p>解决方案和Any一样。</p>
<p>如果结果集为空或者存在多个文档，<strong>Single</strong>&nbsp;会抛出异常</p>
<ul><li><strong>SingleOrDefault</strong></li></ul>
<p><strong>SingleOrDefault</strong>&nbsp;和<strong>Single</strong>&nbsp;用法一样，不同之处在于当集合为空或者存在多个文档对象时，会返回null，而不是抛出异常。</p>
<ul><li><strong>SingleOrDefault</strong><strong>&nbsp;</strong><strong>(</strong><strong>含谓词</strong><strong>)</strong></li></ul>
<p><strong>SingleOrDefault</strong><strong>（含谓词）</strong>&nbsp;和<strong>Single</strong>&nbsp;（含谓词）用法一样，不同之处在于当集合为空或者存在多个文档对象时，会返回null，而不是抛出异常。</p>
<ul><li><strong>Skip</strong></li></ul>
<p>使用<strong>Skip</strong>&nbsp;，指定从结果集开始跳过多少文件。通常情况下，你将结合排序操作使用。</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    orderby c.X<br />
    select c)<br />
    .Skip();

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .OrderBy(c =&gt; c.X)<br />
    .Skip();</pre>
</div>
<ul><li><strong>Take</strong></li></ul>
<p>使用<strong>Take</strong>&nbsp;指定多少文件从服务器返回。结合<strong>Skip</strong>&nbsp;使用时，往往你会指定一个排序顺序。</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    orderby c.X<br />
    select c)<br />
    .Skip()<br />
    .Take();

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .OrderBy(c =&gt; c.X)<br />
    .Skip()<br />
    .Take();</pre>
</div>
<ul><li><strong>ThenBy</strong></li></ul>
<p><strong>ThenBy</strong>&nbsp;是用来指定一个额外的升序排序的结果集。</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    orderby c.X, c.Y<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .OrderBy(c =&gt; c.X)<br />
    .ThenBy(c =&gt; c.Y);</pre>
</div>
<ul><li><strong>ThenByDescending</strong></li></ul>
<p><strong>ThenByDescending</strong>&nbsp;&nbsp;是用来指定一个额外的降序排序的结果集。</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    orderby c.X, c.Y descending<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .OrderBy(c =&gt; c.X)<br />
    .ThenByDescending(c =&gt; c.Y);</pre>
</div>
<ul><li><strong>Where</strong></li></ul>
<p>WHERE子句用于指定返回满足条件查询结果。 WHERE子句是将表达查询文档类型映射到一个布尔值句法。如果表达式返回true则结果匹配到结果集中。</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.X &gt;<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.X &gt; );</pre>
</div>
<p>有时也可以使用多个where字句，其左右相当于&amp;&amp;操作符</p>
<p>例如，下面的查询是等价的：</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.X &gt;<br />
    where c.Y &gt; )<br />
    .First(c.Z &gt; );

// or

var query =<br />
    (from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.X &gt;  &amp;&amp; c.Y &gt;  &amp;&amp; c.Z &gt; )<br />
    .First();</pre>
</div>
<ul><li><strong>EndsWith</strong></li></ul>
<p>此方法用于测试文档对象的字符串类型的字段或者属性是否以某一个特定的字串结束</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.S.EndsWith("abc")<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.S.EndsWith("abc"));</pre>
</div>
<div>
<pre class="prettyprint linenums">//可转化为下面mongodb查询语句（使用了正则表达式）：<br />
{ S : /abc$/ }</pre>
</div>
<ul><li><strong>enum</strong>&nbsp;比较&nbsp;(<strong>==</strong>,&nbsp;<strong>!=</strong>,&nbsp;<strong>&lt;</strong>,&nbsp;<strong>&lt;=</strong>,&nbsp;<strong>&gt;</strong>,&nbsp;<strong>&gt;=</strong>)</li></ul>
<p>枚举字段或者属性可以和同一种类型的枚举常量比较，其真正的比较是基于其底层整数的比较。</p>
<div>
<pre class="prettyprint linenums">public enum E { None, A, B }; 

var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.E == E.A<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.E == E.A);</pre>
</div>
<div>
<pre class="prettyprint linenums">//可转化为下面mongodb查询语句<br />
{ E :  } </pre>
</div>
<div>
<pre class="prettyprint linenums">//LINQ的实现需要考虑序列化后值得表示方式，所以如果你配置了映射类通过字符串而不是整数来存储枚举值，那么将产生下面的MongoDB查询语句：<br />
{ E : "A" }</pre>
</div>
<ul><li><strong>GetType</strong>&nbsp;（返回Type）</li></ul>
<p>这个方法很像OfType方法，会创建一个鉴别器对结果进行更近一步筛选</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.GetType() == typeof(D)<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.GetType() == typeof(D));</pre>
</div>
<div>
<pre class="prettyprint linenums">//可大致转化为下面mongodb查询语句（取决于你创建鉴别器的方式）

{ _t : "D" }</pre>
</div>
<ul><li><strong>In</strong>&nbsp;(LINQ to MongoDB&nbsp;扩展方法)</li></ul>
<p>这个方法用于测试一个字段或者属性是否等于提供的一组值中的任何一个。</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.X.In(new [] { , ,  })<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c.X.In(new [] { , ,  }));</pre>
</div>
<div>
<pre class="prettyprint linenums">//可转化为下面mongodb查询语句：<br />
{ X : { $in : [, , ] } }</pre>
</div>
<ul><li><strong>Inject</strong></li></ul>
<p>该方法是一个&ldquo;伪方法&rdquo;，用于把一个MongoDB查询注入到LINQ中，下面的查询查找大于0的64位整数。</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.X &gt;  &amp;&amp; Query.Type("X", BsonType.Int64).Inject()<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;() .Where(c =&gt; c.X &gt;  &amp;&amp; Query.Type("X", BsonType.Int64).Inject());</pre>
</div>
<div>
<pre class="prettyprint linenums">//可转化为下面mongodb查询语句：<br />
{ X : { $gt : , $type :  } }</pre>
</div>
<div>
<pre class="prettyprint linenums">//is C#关键字<br />
和GetType方法一样</pre>
</div>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where c is D &amp;&amp; ((D)c).B ==<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c is D &amp;&amp; ((D)c).B == );</pre>
</div>
<p>可大致转化为下面mongodb查询语句（取决于你创建鉴别器的方式）</p>
<div>
<pre class="prettyprint linenums">{ _t : "D", B :  }</pre>
</div>
<ul><li><strong>IsMatch</strong>&nbsp;(正则表达式方法)</li></ul>
<p>这个方法用于测试字符串类型的字段或者属性是否匹配一个正则表达式。</p>
<div>
<pre class="prettyprint linenums">var regex = new Regex("^abc");<br />
var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where regex.IsMatch(c.S)<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; regex.IsMatch(c.S));</pre>
</div>
<div>
<pre class="prettyprint linenums">//可转化为下面mongodb查询语句：<br />
{ S : /^abc/ }</pre>
</div>
<div>
<pre class="prettyprint linenums">//也可以使用静态IsMatch方法：

var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where Regex.IsMatch(c.S, "^abc")<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; Regex.IsMatch(c.S, "^abc"));</pre>
</div>
<div>
<pre class="prettyprint linenums">//可转化为下面mongodb查询语句：<br />
{ S : /^abc/ }</pre>
</div>
<ul><li><strong>Length</strong>&nbsp;(数组集合长度)</li></ul>
<p>这个方法用于测试数组集合类型的字段或者属性是否存在一个特定数量的项。</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.A.Length ==<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.A.Length == );</pre>
</div>
<div>
<pre class="prettyprint linenums">//可转化为下面mongodb查询语句：

{ A : { $size:  } }</pre>
</div>
<ul><li><strong>%</strong>&nbsp;(<strong>Mod</strong>运算符)</li></ul>
<p>这个方法用于对文档属性或者字段进行求余运算，下面查询匹配所有x属性为偶数的文档</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.X %  ==<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.X %  == );</pre>
</div>
<div>
<pre class="prettyprint linenums">//可转化为下面mongodb查询语句：

{ X : { $mod : [, ] } }</pre>
</div>
<ul><li><strong>!</strong>&nbsp;(<strong>Not</strong>&nbsp;操作符)</li></ul>
<p>此方法用于对测试结果进行逻辑非操作</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where !(c.X &gt; )<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; !(c.X &gt; ));</pre>
</div>
<div>
<pre class="prettyprint linenums">//可转化为下面mongodb查询语句：

{ X : { $not : { $gt :  } } }</pre>
</div>
<p>注意：</p>
<p>在c.X缺失或者不是数值类型时，!(c.X&nbsp;&gt;&nbsp;1)不等同于&nbsp;(c.X&nbsp;&lt;=&nbsp;1)</p>
<p>数值比较 (==,&nbsp;!=,&nbsp;&lt;,&nbsp;&lt;=,&nbsp;&gt;,&nbsp;&gt;=)</p>
<p>数值类型的字段或者属性可以使用上述任何一种比较方式</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.X ==  &amp;&amp; c.Y &lt;<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.X ==  &amp;&amp; c.Y &lt; );</pre>
</div>
<div>
<pre class="prettyprint linenums">//可转化为下面mongodb查询语句：

{ X : , Y : { $lt :  } }</pre>
</div>
<ul><li><strong>||</strong>&nbsp;(<strong>Or</strong>&nbsp;运算符)</li></ul>
<p>逻辑或运算，进行或比较</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.X &gt;  || c.Y &gt;<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.X &gt;  || c.Y &gt; );</pre>
</div>
<div>
<pre class="prettyprint linenums">//可转化为下面mongodb查询语句：

{ $or : [{ X : { $gt :  } }, { Y : { $gt :  } }] }</pre>
</div>
<ul><li><strong>StartsWith</strong></li></ul>
<p>这个方法用于测试文档对象的字符串字段或者属性是否以某个特定的子串开始</p>
<div>
<pre class="prettyprint linenums">var query =<br />
    from c in collection.AsQueryable&lt;C&gt;()<br />
    where c.S.StartsWith("abc")<br />
    select c;

// or

var query =<br />
    collection.AsQueryable&lt;C&gt;()<br />
    .Where(c =&gt; c.S.StartsWith("abc"));</pre>
</div>
<div>
<pre class="prettyprint linenums">//可转化为下面mongodb查询语句： (可用正则表达式):

{ S : /^abc/ }</pre>
</div>
<ul><li><strong>ToLower</strong>,&nbsp;<strong>ToLowerInvariant</strong>,&nbsp;<strong>ToUpper</strong>,&nbsp;<strong>ToUpperInvariant</strong>这些方法用于使文档对象的字符串字段或者属性转为相应的大小写模式</li></ul>
<div>
<pre class="prettyprint linenums">    var query = from c in collection.AsQueryable&lt;C&gt;()<br />
     where c.S.ToLower() == "abc"<br />
     select c;

 // or

 var query =<br />
     collection.AsQueryable&lt;C&gt;()<br />
     .Where(c =&gt; c.S.ToLower() == "abc");</pre>
</div>
<div>
<pre class="prettyprint linenums">//可转化为下面mongodb查询语句： (可用正则表达式):<br />
{ S : /^abc$/i }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2234lq.html">junit单元测试（keeps the bar green to keeps the code clean&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyddrmjq.html">iOS 学习资料整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjpglk9.html">SequoiaDB（巨杉数据库）（社区版）安装配置使用图解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yvwo0q.html">oracle日期时间函数总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oeew39.html">Swift数据类型之整型和浮点型－备</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljnee19.html">USACO Section 1&period;1 Broken Necklace 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy10x0gq.html">整数中1出现的次数（从1到n的整数中1出现的次数）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mevxo6q.html">Oracle连接出错（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kopn29.html">C&num;添加背景音乐</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpzjw59.html">wpf中静态资源和动态资源的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk00nz8.html">CentOS与Win7远程桌面互通</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ojowx8.html">kong&plus;konga</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5py34q.html">unity3d 给游戏添加音源 Unity3d adds a sound source to the game</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r3wjz8.html">DG备库，实时应用如何判断，MR进程，及MRP应用归档，三种情况的查询及验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4zeym9.html">Go 定时器timer和ticker</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2xx3j9.html">Linux学习笔记-基本操作4</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw6dgv9.html">mysql 之 主从同步（单向同步和双向同步）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95320668.html">2016-2017-2 《Java程序设计》课程总结 - 20155214</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v0zl2q.html">BZOJ1002【FJOI2007】轮状病毒</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppzrl79.html">sae python中Mysql中文乱码的解决</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8omzgpq.html">如何用js实现截取一个字符串中的数字</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx7prd9.html">zabbix&lowbar;server 已死，但是 subsys 被锁</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv46moq.html">记一次hadoop datanode进程问题分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8om72eq.html">Web安全--XSS模版</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gol67q.html">多人操作sqlite3数据库冲突问题解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kx3njq.html">【软件】图文解释XCode常用快捷键的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnpryj8.html">【C&num;】SQL数据库助手类2&period;0（自用）</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4rgr58.html">Tarjian算法求强联通分量</a>
			</li>
						<li><a href="https://www.batexi.com/a/4954x40q.html">AutoIT简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/390zm7mq.html">QTP学习一添加默认的注释及调用外部vbs文件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
